#Metadata
#Aaron Maguire
#28/01/24

#Loads the initial coded file and turn the atlas ti variants of the codes into those matching my code dictionary to compare with my peer coder
#File can't be run as required a file needing textual data, but would exist to change codes from the 'group' versions I had maintained into seperated codes for analysis

##Inputs:
#My codes, sorted alphabetically on user response: "Personal.xlsx"
#Outputs:
#My codes changed to fit the peer coding: "Data_updated.xlsx"

import pandas as pd


#my codes, sorted alphabetically on user response
FILE_1_PATH = "Personal.xlsx"


UNIQUE_CODES = {'Awareness: Cravings as a Concept':'Cravings as a Concept', 'Motivation: Participation':'Participation', 'Motivation: Skepticism':'Skepticism', 'Mental Wellbeing: Exercise Habits':'Exercise Habits', ' Awareness: Distractions':'Distractions', 'Awareness: Exercise as Distraction':'Exercise as Distraction', 'Motivation: \'None\'':'None', 'Awareness: Smoking as Routine':'Smoking as Routine', 'Motivation: Encouraged':'Encouraged', 'Awareness: Negative Awareness':'Negative Awareness', 'Awareness: Smoking as Comfort':'Smoking as Comfort', 'Shame: Stress':'Stress', 'Motivation: Activity Wasn\'t a Priority':'Activity Wasn\'t a Priority', 'Mental Wellbeing: Sleep Habits':'Sleep Habits', 'Motivation: Mindfulness':'Mindfulness', 'Motivation: Goal Setting':'Goal Setting', 'Motivation: Planning Ahead':'Planning Ahead', 'Visualisation: Quantifying Blockers':'Quantifying Blockers', 'Visualisation: Quitting as a Journey':'Quitting as a Journey', 'Motivation: Prioritising Quitting':'Prioritising Quitting', 'Environment: Outside and Inside':'Outside and Inside', 'Environment: Proximity to Other Smokers':'Proximity to Other Smokers', 'Motivation: Self Affirmation':'Self Affirmation', 'Mental Wellbeing: Links with other Addictions':'Links with other Addictions', 'Shame: Perception from Loved Ones':'Preception from Loved Ones', '':'',
                'Motivation: Intentional Reduction':'Intentional Reduction', 'Motivation: Money as a Factor':'Money as a Factor', 'Shame: Money Sink':'Money Sink', 'Motivation: Inspired Research':'Inspired Research', 'Motivation: Optimism':'Optimism', 'Visualisation: Long Term Worries':'Long Term Worries', 'Visualisation: Short Term Worries':'Short Term Worries', 'Motivation: Apathy':'Apathy'}

df = pd.read_excel(FILE_1_PATH)

def map_keys_to_values(cell_content):
    if pd.isna(cell_content):  # If cell is empty
        return cell_content
    else:
        keys = cell_content.split('\n') if '\n' in cell_content else [cell_content]
        values = [UNIQUE_CODES.get(key, key) for key in keys]
        return '\n'.join(values)

# Map the values from the dictionary to the DataFrame
df['CodesFixed'] = df['Codes'].apply(map_keys_to_values)

# Save the updated DataFrame back to the Excel file
df.to_excel('data_updated.xlsx', index=False)