#Metadata
#Aaron Maguire
#28/01/24

#File designed to pair my code file with all the other relevant data for quantative analysis

#Also adapted to pair peer coded files (currently commented out) with the other relevant data

#Won't be usable as requires the codes alphabetically sorted on their relevant plaintext quotation

##Input:
#Any two files of mine (xlsx) with Rand_ID present as a column (requires variable renaming)
##OR
#Any two files of mine with a user response column, as it will pair them

##Output:
#A Paired file, either appended data of codes and themes based on the user response column or an entire file merge based on the rand_id column

import openpyxl
import pandas as pd


#FILE_1_PATH = "file_sorted_and_cleaned_themes_appended.xlsx"
#FILE_1_PATH = "peerfile_sorted_and_cleaned.xlsx"
#My code file, sorted alphabetically on user 
FILE_1_PATH = "file_sortedalphabetically copy.xlsx"
#Unused currently but was used prior to merge my codes with quantative data
FILE_2_PATH = "DataWithPIDS.xlsx"
#User characteristics file to merge with the total end file
FILE_3_PATH = "prolific_profile_anonym.xlsx"
#Later used as the final respository of all quantative data and code information, anything would get appended to this
FILE_4_PATH = "OutputAllDataAndCodes.xlsx"

wbF1 = openpyxl.load_workbook(filename = FILE_1_PATH, read_only=False)
file_1 = wbF1.active

df2 = pd.read_excel(FILE_4_PATH)

def modified_contentO(s):
    return ''.join(filter(str.isalpha, s))

#add 'themes' to the quotation init for option 1
class Quotation:
    def __init__(self, content, codes, 
                 #themes):
    ):
        if content is  None: # in case a None value got into the dataset
            self.content = ''
        else:
            self.content = content
        self.codes = codes.split('\n')
    #    self.themes = themes.split('\n')
        if len(self.codes) == 1:
            self.codes = self.codes[0].split(',') # Split the codes into a list
    #    if len(self.themes) == 1:
            #self.themes = self.themes[0].split(',') # Split the themes into a list
        

    def __eq__(self, __value: object) -> bool:
        if isinstance(__value, Quotation):
            return self.modified_content() == __value.modified_content()
        return False
    
    def __hash__(self):
        return hash(self.modified_content())
    

    def modified_content(s):
        return ''.join(filter(str.isalpha, s))

#list for all the quotation datatype    
quotations_1 = [];

if __name__ == "__main__":
    # Retrieve the active sheet from each of the 2 files
    file_1 = openpyxl.load_workbook(FILE_1_PATH).active

    # Iterate through all the rows to initialize the Quotation lists for each file
    cnt_row = file_1.max_row
    quotations_1, quotations_2 = list(), list()
    for i in range(1, cnt_row + 1):
        # Get the data from the current row of file 1
        content_1 = str(file_1.cell(row = i, column = 3).value).lower().replace(' ', '')
        codes_1 = str(file_1.cell(row = i, column = 5).value).lower().replace(' ', '')
        #themes_1 = str(file_1.cell(row = i, column = 9).value).lower().replace(' ', '')
        
        quotation_1 = Quotation(content_1, codes_1)
        #quotation_1 = Quotation(content_1, codes_1, themes_1) # Cast the retrieved data to a Quotation

        # Add the Quotations to their respective lists
        quotations_1.append(quotation_1)

#for each code found, append it to the correct column in the dataframe
def appendCodes(row):
    codeCounter = 0
    for quote in quotations_1:
        if not isinstance(row['Quotations'], float): 
            if modified_contentO(row['Quotations']).lower()[:30] == modified_contentO(quote.content)[:30]:
                codeCounter +=1
                return quote.codes
    return [] 

#for each theme found, append it to the correct column in the datafame
def appendThemes(row):
    themeCounter = 0
    for quote in quotations_1:
        if not isinstance(row['Quotations'], float): 
            if modified_contentO(row['Quotations']).lower()[:30] == modified_contentO(quote.content)[:30]:
                themeCounter +=1
                return quote.themes
    return [] 

df2['OriginalCodes'] = df2.apply(appendCodes, axis=1)
#df2['Themes'] = df2.apply(appendThemes, axis=1)

df2.to_excel('OutputAllCodesAndDataFinal.xlsx', index=False)

#additional code now commented out which would merge files which had the PID field, sometimes called PID, sometimes rand_id, sometimes Unnamed: 0
#df3 = pd.read_excel(FILE_3_PATH)

#merged_df = pd.merge(df2, df3, left_on='Unnamed: 0', right_on='rand_id')


#merged_df.to_excel('OutputAllCodesAndDataFinal.xlsx', index=False)