#Metadata
#Aaron Maguire
#28/01/24
#Very simple file for grabbing the data and appending it to a bigger file to perform checks with codes and themes
#Can't be run without the full dataset as it requires confidential information to operate

##Inputs
#The user's quantative data mapped to their rand_id: "prolific_profile_anonym.xlsx"
#The session data, as quantative data was gathered from users who didn't go on to complete session 1

##Output
#A file essentially the same as ProcessedSessionsData but with their quantative data appended if they participated in at least 1 session


import openpyxl
import numpy as np

FILE_1_PATH = "prolific_profile_anonym.xlsx"

#This is the sessiondata_anonym from the confidential data where the second column with comma seperate variables is translated into many columns
#Then the postquestionnaire_anonym is appended as a sixth session to produce "ProcessedSessionsData"
File_2_Path = "ProcessedSessionsData.xlsx"

#array of education levels
education_Levels = ["No formal qualifications", "Secondary education (e.g. GED/GCSE)", "High school diploma/A-levels", "Technical/community college", "Undergraduate degree (BA/BSc/other)", "Graduate degree (MA/MSc/MPhil/other)", "Doctorate degree (PhD/other)", "Don't know / not applicable"]
education_Level_Counter = [0, 0, 0, 0, 0, 0, 0, 0]

gender_identity = ["Man (including Trans Male/Trans Man)", "Woman (including Trans Female/Trans Woman)", "Non-binary (would like to give more detail)", "Rather not say"]
gender_quantity = [0, 0, 0, 0]

age_Total = 0
age_valid = 0
#loop through file 2, grab all PIDs
PID = []
ages = []

file_2 = openpyxl.load_workbook(File_2_Path).active

cnt_row = file_2.max_row
for i in range(2, cnt_row):
    grabbedPID = str(file_2.cell(row = i, column = 1).value)
    if grabbedPID not in PID and grabbedPID is not "None":
        PID.append(grabbedPID)


file_1 = openpyxl.load_workbook(FILE_1_PATH).active

cnt_row = file_1.max_row

#go through each row of quantative data in prolific
for i in range(2, cnt_row):
    grabbedEdu = str(file_1.cell(row = i, column = 3).value)
    grabbedPID = str(file_1.cell(row = i, column = 5).value)
    grabbedGender = str(file_1.cell(row = i, column = 2).value)
    grabbedAge = int(file_1.cell(row = i, column = 4).value)
#if the PID is present in session 1 onwards
    if grabbedPID in PID:
#append all the relevant data from that user
        education_Level_Counter[education_Levels.index(grabbedEdu)] += 1
        ages.append(grabbedAge)
        gender_quantity[gender_identity.index(grabbedGender)] += 1



#prints distribution of education level
print(education_Level_Counter)
print("Age mean:" + str(np.mean(ages)))
print("Age Std:" + str(np.std(ages)))
#prints distribution of genders
print(gender_quantity)